//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
//#property indicator_level1  0
#property indicator_minimum 0
#property indicator_maximum 1
//#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int Price          = PRICE_CLOSE;
extern int MomentumPeriod = 15;

//double vol[];
double price[];
double histoup[];
double histodn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0, histoup); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1, histodn); SetIndexStyle(1, DRAW_HISTOGRAM);
      //SetIndexBuffer(0,vol);
      SetIndexBuffer(2,price);
      IndicatorShortName("Directional momentum 2 ("+MomentumPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
      for(int i = limit; i>=0; i--)
      {
         price[i]   =  iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double moa =  0; for (int k = 0; k<MomentumPeriod; k++) moa += MathAbs(price[i+k]-price[i+k+1]);
         double mom =  iMomentumS(MomentumPeriod,i);
         
         //
         //
         //
         //
         //
         
         histoup[i] = EMPTY_VALUE;
         histodn[i] = EMPTY_VALUE;
                
         if (mom>0)
                  histoup[i] =  1;  //moa;
         else     histodn[i] =  1;  //-moa; 
             
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iMomentumS(double length, int i)
{
   double suma = 0.0, sumwa=0;
   double sumb = 0.0, sumwb=0;

      for(int k=0; k<length; k++)
      {
         double weight = length-k;
            suma  += price[i+k] * weight;
            sumb  += price[i+k] * weight * weight;
            sumwa += weight;
            sumwb += weight*weight;
      }
   return(sumb/sumwb-suma/sumwa);
}